(
(
( 8086 MS-Dos target definitions
(
( 8086 Register use: )
(
( AX - tmp )
( BX - always Top Of Stack )
( CX - loop counter )
( DX - tmp )
( SI - ? )
( DI - ? )
( BP - Return stack pointer )
( SP - Data stack pointer )

__( FILE=arch/8086/def.4th )

HEX

( temp solution, must be included in kernel )
: >NAME 3 + ;

__( Building 8086 crosscompile macro's )
ONLY FORTH ALSO DEFINITIONS

VARIABLE TLASTDEPTH
VARIABLE TCOMPILING  TCOMPILING ON
: T[ TCOMPILING OFF ;
: T] TCOMPILING ON ;

VARIABLE TFIXUP
VARIABLE TLASTINSTR
: TCELL
   0002 ;
: TALLOC
   KERNPOS +! ;
: TC, ( c --  ; write char to kernelimage )
   KERNPOS @ C! 1 TALLOC ;
: T,  ( n --  ; write integer to kernelimage )
   0100 U/MOD SWAP TC, TC, ;
: T!
   KERNSTART @ + ! ;
: T@
   KERNSTART @ + @ ;
: TDUP
   DUP ;
: TWASINSTR ( instr -- fl  ; Test if instr was last instruction )
   TLASTINSTR @ = ;

VARIABLE TLASTDEF
: TIC,    DUP TLASTINSTR ! TC, ;
: TIS,    DUP TLASTINSTR !  T, ;
: TCLROPT 0 TLASTINSTR ! ;
: THERE   KERNPOS @ KERNSTART @ - ;
: TVOC    TLASTDEF @ ;


: T_ADD_BX,AX            D803 TIS, ;
: T_ADD_[BX],AX          0701 TIS, ;
: T_ADD_BP,#             C583 TIS, TC, ;
: T_ADD_CX,BX            CB03 TIS, ;

: T_AND_BX,AX            D823 TIS, ;

: T_BREAK                00CC TIC, ;

: T_CALL_AX              D0FF TIS, ;
: T_CALL_#               00E8 TIC, THERE - 0002 - T, ;
: T_CMP_BX,AX            D83B TIS, ;
: T_CMP_CX,DX            CA3B TIS, ;

: T_DEC_BX               004B TIC, ;

: T_DIV_BX               F3F7 TIS, ;

: T_FIXFWD               DUP 0<> IF THERE OVER - 0002 - SWAP T!
                         ELSE DROP ENDIF ; ( See also T_JMPFWD )

: T_INC_CX               0041 TIC, ;

: T_INT_#                00CD TIC, TC, ;

: T_JE                   0074 TIC, ;
: T_JG                   007F TIC, ;
: T_JGE                  007D TIC, ;
: T_JL                   007C TIC, ;
: T_JLE                  007E TIC, ;
: T_JNE                  0075 TIC, ;
: T_JMP_#                00E9 TIC, THERE - 0002 - T, ;
: T_JMPFWD               00E9 TIC, THERE 0 T, ;

: T_LIT                  0053 TIC, ( push_bx ) 00BB TIC, T, ( MOV_BX,# ) ;

: T_NEGATE               DBF7 TIS, ;

: T_MOV_AX,BX            C38B TIS, ;
: T_MOV_AX,SP            C48B TIS, ;
: T_MOV_AX,#             00B8 TIC, T, ;
: T_MOV_BX,AX            D88B TIS, ;
: T_MOV_BX,CX            D98B TIS, ;
: T_MOV_BX,DX            DA8B TIS, ;
: T_MOV_BX,[BX]          1F8B TIS, ;
: T_MOV_BX,#[BP]         5E8B TIS, TC, ;
: T_MOV_BX,#             00BB TIC, T, ;
: T_MOV_BL,[BX]          1F8A TIS, ;
: T_MOV_BH,#             00B7 TIC, TC, ;
: T_MOV_[BX],AL          0788 TIS, ;
: T_MOV_[BX],AX          0789 TIS, ;
: T_MOV_[BX],BP          2F89 TIS, ;
: T_MOV_[BX],SP          2789 TIS, ;
: T_MOV_BP,[BX]          2F8B TIS, ;
: T_MOV_CX,BX            CB8B TIS, ;
: T_MOV_DX,BX            D38B TIS, ;
: T_MOV_DX,#[BP]         568B TIS, TC, ;
: T_MOV_SP,[BX]          278B TIS, ;

: T_MUL_BX               E3F7 TIS, ;

: T_OR_BX,AX             D80B TIS, ;

: T_POP_AX               0058 TIC, ;
: T_POP_BX               005B TIC, ;
: T_POP_CX               0059 TIC, ;
: T_POP_DX               005A TIC, ;
: T_PUSH_AX              0050 TIC, ;
: T_PUSH_BX              0053 TIC, ;
: T_PUSH_CX              0051 TIC, ;
: T_PUSH_DX              0052 TIC, ;

: T_RET                  00C3 TIC, ;
: T_RETF                 00CB TIC, ;

: T_SAR_BX,1             FBD1 TIS, ;
: T_SBB_BX,BX            DB1B TIS, ;
: T_SUB_BX,AX            D82B TIS, ;
: T_SUB_BX,#             EB83 TIS, TC, ;
: T_SUB_DX,DX            D22B TIS, ;
: T_SWITCH               EC87 TWASINSTR IF
                           -2 TALLOC TCLROPT
                         ELSE EC87 TIS, ENDIF ;

: T_TEST_BX,BX           ( DB1B WASINSTR NIF ) DB85 TIS, ( ENDIF ) ;

: T_XCHG_AX,BX           0093 TIC, ;
: T_XCHG_#[BP],AX        4687 TIS, TC, ;
: T_XCHG_#[BP],BX        5E87 TIS, TC, ;

: T_>R                   T_SWITCH T_PUSH_BX T_SWITCH T_POP_BX ;


: TCOPYNAME
   >NAME DUP C@ 1+ 0 DO DUP @ TC, 1+ LOOP DROP ;

: VARHEADER
   HERE CREATE
   THERE TLASTDEF DUP @ T, ! FLAG_VARIABLE TC,  ( link + type )
   TCOPYNAME THERE ,
   DOES> @ 2+ TCOMPILING @ IF T_LIT ENDIF ;

: CONSTHEADER
   HERE CREATE
   THERE TLASTDEF DUP @ T, ! FLAG_CONSTANT TC,  ( link + type )
   TCOPYNAME THERE ,
   DOES> @ 2+ DUP . T@ DUP . TCOMPILING @ IF T_LIT ENDIF ;

: PROCHEADER
   HERE CREATE
   THERE TLASTDEF DUP @ T, ! FLAG_PROCEDURE TC,  ( link + type )
   TCOPYNAME THERE ,
   DOES> @ T@ TCOMPILING @ IF T_SWITCH T_CALL_# T_SWITCH ENDIF ;

__( Building crosscompiler )
ONLY FORTH ALSO CROSS DEFINITIONS

: CREATE
   VARHEADER
   0000 T, ;

: ALLOT
   TALLOC ;

: VARIABLE
   VARHEADER
   0000 T, 0000 T, ( value ) ;

: CONSTANT
   CONSTHEADER
   0000 T, T, ( value ) ;

: ASCII
   0020 WORD 1+ C@ T_LIT ;

: C"
   T_JMPFWD THERE SWAP
   ASCII " WORD DUP C@ 1+ 0 DO DUP C@ TC, 1+ LOOP DROP
   T_FIXFWD T_LIT ;

__( Crosscompiling control structures )
: BEGIN ( -- oldfixup a1 )
   TFIXUP @ 0 TFIXUP ! THERE
   TCLROPT ;
: WHILE ( a1 -- afix a1 )
   T_TEST_BX,BX T_POP_BX
   T_JNE 3 TC, T_JMPFWD SWAP
   1 TFIXUP +! ;
: UNTIL ( oldfixup .. afix a1 -- )
   T_TEST_BX,BX T_POP_BX
   T_JNE 3 TC, T_JMP_#
   TFIXUP @ 0 2DUP <> IF
      DO T_FIXFWD LOOP
   ELSE 2DROP
   ENDIF TFIXUP ! TCLROPT ;
: REPEAT ( oldfixup .. afix a1 -- )
   T_JMP_#
   TFIXUP @ 0 2DUP <> IF
      DO T_FIXFWD LOOP
   ELSE 2DROP
   ENDIF TFIXUP ! TCLROPT ;
: IF ( -- afix )
   T_TEST_BX,BX T_POP_BX
   T_JNE 3 TC, T_JMPFWD
   TCLROPT ;
: NIF ( -- afix )
   T_TEST_BX,BX T_POP_BX
   T_JE 3 TC, T_JMPFWD
   TCLROPT ;
: ELSE ( afix -- afix )
   T_JMPFWD SWAP T_FIXFWD
   TCLROPT ;
: ENDIF ( afix -- )
   T_FIXFWD
   TCLROPT ;

: DO ( Compile: -- afix1 afix2  )
     ( Runtime: lim start --  ; begin loop )
   T_SWITCH T_PUSH_CX T_SWITCH   ( Store CX=counter )
   T_MOV_CX,BX T_POP_BX T_>R ( Init counter and limit )
   0 THERE ( Jumpback addr ) ;
: ?DO ( Compile: -- afix1 afix2 )
      ( Runtime: lim start --  ; begin loop )
   T_SWITCH T_PUSH_CX T_SWITCH ( Store CX=counter )
   T_MOV_CX,BX T_POP_BX T_MOV_DX,BX T_>R ( Init counter and limit )
   T_CMP_CX,DX T_JL 3 TC, T_JMPFWD THERE ; ( Jumpback addr )
: LOOP ( Compile: afix1 afix2 --  ; End a loop construct )
       ( Runtime: -- )
   T_INC_CX 0 T_MOV_DX,#[BP]
   T_CMP_CX,DX T_JGE 3 TC, T_JMP_#
   T_FIXFWD T_SWITCH  T_POP_CX T_POP_CX T_SWITCH ;
: +LOOP ( Compile: afix1 afix2 --  ; End a loop construct )
        ( Runtime: n1 -- )
   T_ADD_CX,BX T_POP_BX 0 T_MOV_DX,#[BP]
   T_CMP_CX,DX T_JGE 3 TC, T_JMP_#
   T_FIXFWD T_SWITCH  T_POP_CX T_POP_CX T_SWITCH ;
: I           T_PUSH_BX T_MOV_BX,CX ;
: J           T_PUSH_BX 2 T_MOV_BX,#[BP] ;
: K           T_PUSH_BX 6 T_MOV_BX,#[BP] ;

: >R          T_SWITCH T_PUSH_BX T_SWITCH T_POP_BX ;
: R>          T_PUSH_BX T_SWITCH T_POP_BX T_SWITCH ;
: R@          T_PUSH_BX 0 T_MOV_BX,#[BP] ;

: 1+          0043 TIC, ;
: 1-          T_DEC_BX ;
: 2+          4343 TIS, ;
: 2-          4B4B TIS, ;
: NEGATE      T_NEGATE ;

: =           T_POP_AX T_SUB_BX,AX 1 T_SUB_BX,# T_SBB_BX,BX ;
: 0=          1 T_SUB_BX,# T_SBB_BX,BX ;
: <>          T_POP_AX T_SUB_BX,AX T_NEGATE T_SBB_BX,BX ;
: 0<>         T_NEGATE T_SBB_BX,BX ;
: <           T_POP_AX T_CMP_BX,AX 0 T_MOV_BX,#
              T_JLE 1 TC, T_DEC_BX ;
: <=          T_POP_AX T_CMP_BX,AX 0 T_MOV_BX,#
              T_JL  1 TC, T_DEC_BX ;
: >           T_POP_AX T_CMP_BX,AX 0 T_MOV_BX,#
              T_JGE 1 TC, T_DEC_BX ;
: >=          T_POP_AX T_CMP_BX,AX 0 T_MOV_BX,#
              T_JG  1 TC, T_DEC_BX ;
: AND         T_POP_AX T_AND_BX,AX ;
( : NOT        T_SHL_BX,1 T_SBB_BX,BX ;
: OR          T_POP_AX T_OR_BX,AX ;

: +           T_POP_AX T_ADD_BX,AX ;
: -           T_MOV_AX,BX T_POP_BX T_SUB_BX,AX ;
: *           T_MOV_AX,BX T_POP_BX T_MUL_BX T_MOV_BX,AX ;
: U/MOD       T_POP_AX T_SUB_DX,DX T_DIV_BX
              T_PUSH_DX T_MOV_BX,AX ;
: UM/MOD      T_POP_DX T_POP_AX T_DIV_BX T_PUSH_DX
              T_MOV_BX,AX ;

: @           T_MOV_BX,[BX] ;
: !           T_POP_AX T_MOV_[BX],AX T_POP_BX ;
: +!          T_POP_AX T_ADD_[BX],AX T_POP_BX ;
: C@          T_MOV_BL,[BX] 0 T_MOV_BH,# ;
: C!          T_POP_AX T_MOV_[BX],AL T_POP_BX ;

: DROP        T_POP_BX ;
: DUP         T_PUSH_BX ;
: NIP         T_POP_AX ;
: OVER        T_POP_AX T_PUSH_AX T_XCHG_AX,BX T_PUSH_AX ;
: ROT         T_POP_DX T_POP_AX T_PUSH_DX
              T_XCHG_AX,BX T_PUSH_AX ;
: -ROT        T_POP_DX T_POP_AX T_PUSH_BX
              T_MOV_BX,DX T_PUSH_AX ;
: SWAP        T_POP_AX T_XCHG_AX,BX T_PUSH_AX ;
: CLR         0 T_MOV_BX,# ;

: 2DROP       T_POP_BX T_POP_BX ;
: 2DUP        T_POP_AX T_PUSH_AX T_PUSH_BX T_PUSH_AX ;
: 2SWAP ( n1 n2 n3 n4 -- n3 n4 n1 n2 )
              T_POP_AX T_SWITCH 2 T_XCHG_#[BP],AX
              0 T_XCHG_#[BP],BX T_SWITCH T_PUSH_AX ;

: 3DROP       T_POP_BX T_POP_BX T_POP_BX ;
: 3DUP        T_POP_AX T_POP_DX T_PUSH_DX
              T_PUSH_AX T_PUSH_BX T_PUSH_DX T_PUSH_AX ;

: EXECUTE     T_MOV_AX,BX T_POP_BX T_SWITCH
              T_CALL_AX T_SWITCH ;

: :
   PROCHEADER THERE 2+ T, TCLROPT T_SWITCH DEPTH TLASTDEPTH ! ;
: ;
   T_SWITCH T_RET DEPTH TLASTDEPTH @ <>
   IF CR C" Stack depth changed while defining " TYPES
   TLASTDEF @ KERNSTART @ + 3 + TYPES CR KEY DROP ELSE
   CR C" Build: " TYPES TLASTDEF @ KERNSTART @ + 3 + TYPES
   ENDIF ;

: IMMEDIATE
   TLASTDEF @ KERNSTART @ + 2+ DUP C@ FLAG_IMMEDIATE OR SWAP C! ;
: HIDDEN
   TLASTDEF @ KERNSTART @ + 2+ DUP C@ FLAG_HIDDEN OR SWAP C! ;

