(
(
( VM target definitions
(

__( FILE=arch/VM/def.4th )

HEX

: >NAME CELL + 1+ ;

__( Building VM crosscompile macro's )
ONLY FORTH ALSO DEFINITIONS

VARIABLE TLASTDEPTH
VARIABLE TCOMPILING  TCOMPILING ON
: T[ TCOMPILING OFF ;
: T] TCOMPILING ON ;

VARIABLE TFIXUP
VARIABLE TLASTINSTR
: TCELL
   0004 ;
: TCELL+
   TCELL + ;
: TALLOC
   KERNPOS +! ;
: TC, ( c --  ; write char to kernelimage )
   KERNPOS @ C! 1 TALLOC ;
: T,  ( n --  ; write integer to kernelimage )
   0000 TC, 0000 TC, 0100 U/MOD TC, TC, ;
: TC!
   KERNSTART @ + C! ;
: T!
   KERNSTART @ + DUP ROT 0100 U/MOD ROT C! SWAP 1+ C! ; 
: T@
   KERNSTART @ + @ ;
: TDUP
   DUP ;
: TWASINSTR ( instr -- fl  ; Test if instr was last instruction )
   TLASTINSTR @ = ;

VARIABLE TLASTDEF
: TIC,    DUP TLASTINSTR ! TC, ;
: TIS,    DUP TLASTINSTR !  T, ;
: TCLROPT 0 TLASTINSTR ! ;
: THERE   KERNPOS @ KERNSTART @ - ;
: TVOC    TLASTDEF @ ;
: T_LIT   0020 TIC, T, ;


: TCOPYNAME
   >NAME DUP C@ 1+ 0 DO DUP @ TC, 1+ LOOP DROP ;

: VARHEADER
   HERE CREATE
   THERE TLASTDEF DUP @ T, ! FLAG_VARIABLE TC,  ( link + type )
   TCOPYNAME THERE ,
   DOES> @ 2+ TCOMPILING @ IF T_LIT ENDIF ;

: CONSTHEADER
   HERE CREATE
   THERE TLASTDEF DUP @ T, ! FLAG_CONSTANT TC,  ( link + type )
   TCOPYNAME THERE ,
   DOES> @ 2+ DUP . T@ DUP . TCOMPILING @ IF T_LIT ENDIF ;

: PROCHEADER
   HERE CREATE
   THERE TLASTDEF DUP @ T, ! FLAG_PROCEDURE TC,  ( link + type )
   TCOPYNAME THERE ,
   DOES> @ T@ TCOMPILING @ IF T_SWITCH T_CALL_# T_SWITCH ENDIF ;

__( Building crosscompiler )
ONLY FORTH ALSO CROSS DEFINITIONS

: CREATE
   VARHEADER
   0000 T, ;

: ALLOT
   TALLOC ;

: VARIABLE
   VARHEADER
   0000 T, 0000 T, ( value ) ;

: CONSTANT
   CONSTHEADER
   0000 T, T, ( value ) ;

: ASCII
   0020 WORD 1+ C@ T_LIT ;

: C"
   T_JMPFWD THERE SWAP
   ASCII " WORD DUP C@ 1+ 0 DO DUP C@ TC, 1+ LOOP DROP
   T_FIXFWD T_LIT ;

__( Crosscompiling control structures )
: BEGIN ( -- oldfixup a1 )
   TFIXUP @ 0 TFIXUP ! THERE
   TCLROPT ;
: WHILE ( a1 -- afix a1 )
   T_TEST_BX,BX T_POP_BX
   T_JNE 3 TC, T_JMPFWD SWAP
   1 TFIXUP +! ;
: UNTIL ( oldfixup .. afix a1 -- )
   T_TEST_BX,BX T_POP_BX
   T_JNE 3 TC, T_JMP_#
   TFIXUP @ 0 2DUP <> IF
      DO T_FIXFWD LOOP
   ELSE 2DROP
   ENDIF TFIXUP ! TCLROPT ;
: REPEAT ( oldfixup .. afix a1 -- )
   T_JMP_#
   TFIXUP @ 0 2DUP <> IF
      DO T_FIXFWD LOOP
   ELSE 2DROP
   ENDIF TFIXUP ! TCLROPT ;
: IF ( -- afix )
   T_TEST_BX,BX T_POP_BX
   T_JNE 3 TC, T_JMPFWD
   TCLROPT ;
: NIF ( -- afix )
   T_TEST_BX,BX T_POP_BX
   T_JE 3 TC, T_JMPFWD
   TCLROPT ;
: ELSE ( afix -- afix )
   T_JMPFWD SWAP T_FIXFWD
   TCLROPT ;
: ENDIF ( afix -- )
   T_FIXFWD
   TCLROPT ;

: DO ( Compile: -- afix1 afix2  )
     ( Runtime: lim start --  ; begin loop )
   T_SWITCH T_PUSH_CX T_SWITCH   ( Store CX=counter )
   T_MOV_CX,BX T_POP_BX T_>R ( Init counter and limit )
   0 THERE ( Jumpback addr ) ;
: ?DO ( Compile: -- afix1 afix2 )
      ( Runtime: lim start --  ; begin loop )
   T_SWITCH T_PUSH_CX T_SWITCH ( Store CX=counter )
   T_MOV_CX,BX T_POP_BX T_MOV_DX,BX T_>R ( Init counter and limit )
   T_CMP_CX,DX T_JL 3 TC, T_JMPFWD THERE ; ( Jumpback addr )
: LOOP ( Compile: afix1 afix2 --  ; End a loop construct )
       ( Runtime: -- )
   T_INC_CX 0 T_MOV_DX,#[BP]
   T_CMP_CX,DX T_JGE 3 TC, T_JMP_#
   T_FIXFWD T_SWITCH  T_POP_CX T_POP_CX T_SWITCH ;
: +LOOP ( Compile: afix1 afix2 --  ; End a loop construct )
        ( Runtime: n1 -- )
   T_ADD_CX,BX T_POP_BX 0 T_MOV_DX,#[BP]
   T_CMP_CX,DX T_JGE 3 TC, T_JMP_#
   T_FIXFWD T_SWITCH  T_POP_CX T_POP_CX T_SWITCH ;
: I           T_PUSH_BX T_MOV_BX,CX ;
: J           T_PUSH_BX 2 T_MOV_BX,#[BP] ;
: K           T_PUSH_BX 6 T_MOV_BX,#[BP] ;

: >R          T_SWITCH T_PUSH_BX T_SWITCH T_POP_BX ;
: R>          T_PUSH_BX T_SWITCH T_POP_BX T_SWITCH ;
: R@          T_PUSH_BX 0 T_MOV_BX,#[BP] ;

: 1+          0030 TIC, ;
: 1-          0031 TIC, ;
: 2+          0030 TIC, 0030 TIC, ;
: 2-          0031 TIC, 0031 TIC, ;
: NEGATE      T_NEGATE ;

: =           T_POP_AX T_SUB_BX,AX 1 T_SUB_BX,# T_SBB_BX,BX ;
: 0=          1 T_SUB_BX,# T_SBB_BX,BX ;
: <>          T_POP_AX T_SUB_BX,AX T_NEGATE T_SBB_BX,BX ;
: 0<>         T_NEGATE T_SBB_BX,BX ;
: <           T_POP_AX T_CMP_BX,AX 0 T_MOV_BX,#
              T_JLE 1 TC, T_DEC_BX ;
: <=          T_POP_AX T_CMP_BX,AX 0 T_MOV_BX,#
              T_JL  1 TC, T_DEC_BX ;
: >           T_POP_AX T_CMP_BX,AX 0 T_MOV_BX,#
              T_JGE 1 TC, T_DEC_BX ;
: >=          T_POP_AX T_CMP_BX,AX 0 T_MOV_BX,#
              T_JG  1 TC, T_DEC_BX ;
: AND         T_POP_AX T_AND_BX,AX ;
( : NOT        T_SHL_BX,1 T_SBB_BX,BX ;
: OR          T_POP_AX T_OR_BX,AX ;

: +           0040 TIC, ;
: -           0041 TIC, ;
: *           0042 TIC, ;
: U/MOD       T_POP_AX T_SUB_DX,DX T_DIV_BX
              T_PUSH_DX T_MOV_BX,AX ;
: UM/MOD      T_POP_DX T_POP_AX T_DIV_BX T_PUSH_DX
              T_MOV_BX,AX ;

: @           0021 TIC, ;
: !           0022 TIC, ;
: +!          T_POP_AX T_ADD_[BX],AX T_POP_BX ;
: C@          0023 TIC, ;
: C!          0024 TIC, ;

: DROP        0011 TIC, ;
: DUP         0010 TIC, ;
: NIP         0013 TIC, ;
: OVER        0014 TIC, ;
: ROT         T_POP_DX T_POP_AX T_PUSH_DX
              T_XCHG_AX,BX T_PUSH_AX ;
: -ROT        T_POP_DX T_POP_AX T_PUSH_BX
              T_MOV_BX,DX T_PUSH_AX ;
: SWAP        0012 TIC, ;
: CLR         0 T_MOV_BX,# ;

: 2DROP       0011 TIC, 0011 TIC, ;
: 2DUP        T_POP_AX T_PUSH_AX T_PUSH_BX T_PUSH_AX ;
: 2SWAP ( n1 n2 n3 n4 -- n3 n4 n1 n2 )
              T_POP_AX T_SWITCH 2 T_XCHG_#[BP],AX
              0 T_XCHG_#[BP],BX T_SWITCH T_PUSH_AX ;

: 3DROP       0011 TIC, 0011 TIC, 0011 TIC, ;
: 3DUP        T_POP_AX T_POP_DX T_PUSH_DX
              T_PUSH_AX T_PUSH_BX T_PUSH_DX T_PUSH_AX ;

: EXECUTE     T_MOV_AX,BX T_POP_BX T_SWITCH
              T_CALL_AX T_SWITCH ;

: :
   PROCHEADER THERE TCELL+ T, TCLROPT ( DEPTH TLASTDEPTH ! ) ;
: ;
   007F TIC,
   ( DEPTH TLASTDEPTH @ <> )
   ( IF CR C" Stack depth changed while defining " TYPES )
   ( TLASTDEF @ KERNSTART @ + >NAME TYPES CR KEY DROP ELSE )
   ( CR C" Build: " TYPES TLASTDEF @ KERNSTART @ + >NAME TYPES )
   ENDIF ;

: IMMEDIATE
   TLASTDEF @ KERNSTART @ + TCELL+ DUP C@ FLAG_IMMEDIATE OR SWAP C! ;
: HIDDEN
   TLASTDEF @ KERNSTART @ + TCELL+ DUP C@ FLAG_HIDDEN OR SWAP C! ;

