
VOCABULARY CROSS
VOCABULARY TARGET
ONLY FORTH ALSO DEFINITIONS

32000 CONSTANT KERNELSTARTOFFSET


VARIABLE DEFFILENAME
VARIABLE KERNFILENAME
VARIABLE CPUFILENAME
VARIABLE IOFILENAME
VARIABLE SYSINITFILENAME
VARIABLE TARGETFILENAME

VARIABLE KERNSTART
VARIABLE KERNPOS


: __(
   CR ['] .( EXECUTE ;

: CROSSMSG ( --  ; Display cross compiler startup banner )
   CR CR
   C" MPForth kernel cross compiler" TYPES CR
   C" Select platform" TYPES CR CR
   C" * 0 - 8086+ Real-mode MS-Dos    (CELL=16 bits)" TYPES CR
   C"   3 - 80386+ Real-mode MS-Dos   (CELL=32 bits)" TYPES CR
   C"   6 - 6502 Commodore64          (CELL=16 bits)" TYPES CR
   C"   L - Intel Linux               (CELL=32 bits)" TYPES CR
   C"   R - ReactOS                   (CELL=32 bits)" TYPES CR
   C" * V - VirtualMachine target     (CELL=32 bits)" TYPES CR
   C"   W - Windows95/98/WinNT        (CELL=32 bits)" TYPES CR CR
   ;

: SETKERNNAME
   C" KERNEL\KERNMAIN.4TH" KERNFILENAME ! ;

VARIABLE SELECTOK
VARIABLE PLATFORM
: CROSSSELECT ( --  ; Select correct include files for cross compile )
   0 SELECTOK !
   BEGIN
      KEY TOUPPER PLATFORM !

      PLATFORM @ ASCII 0 = IF
         SELECTOK ON C" 8086+ selected" TYPES CR
         C" ARCH\8086\DEF.4TH" DEFFILENAME !
         C" ARCH\8086\CPU.4TH" CPUFILENAME !
         C" ARCH\8086\IO.4TH" IOFILENAME !
         C" ARCH\8086\SYSINIT.4TH" SYSINITFILENAME !
         C" 8086DOS.BIN" TARGETFILENAME !
      ENDIF
      PLATFORM @ ASCII 3 = IF
         SELECTOK ON C" 80386+ selected" TYPES CR
         C" ARCH\80386\DEF.4TH" DEFFILENAME !
         C" ARCH\80386\CPU.4TH" CPUFILENAME !
         C" ARCH\80386\IO.4TH" IOFILENAME !
         C" ARCH\80386\SYSINIT.4TH" SYSINITFILENAME !
         C" 80386DOS.BIN" TARGETFILENAME !
      ENDIF
      PLATFORM @ ASCII V = IF
         SELECTOK ON C" Virtual machine selected" TYPES CR
         C" ARCH\VM\DEF.4TH" DEFFILENAME !
         C" ARCH\VM\CPU.4TH" CPUFILENAME !
         C" ARCH\VM\IO.4TH" IOFILENAME !
         C" ARCH\VM\SYSINIT.4TH" SYSINITFILENAME !
         C" VM32CPP.BIN" TARGETFILENAME !
      ENDIF
   SELECTOK @ UNTIL ;

VARIABLE HNDL
: WRITEKERNEL ( addr len -- )
   DECIMAL OVER U. CR DUP U. HEX
   TARGETFILENAME @ COUNT 0 CREATE-FILE IF
      C" Error creating kernel file." TYPES CR
   ELSE
      HNDL !
      HNDL @ WRITE-FILE 2DROP
      HNDL @ CLOSE-FILE
   ENDIF ;

CROSSMSG
CROSSSELECT
SETKERNNAME

DEFFILENAME @ COUNT FILEINCL
ONLY FORTH ALSO DEFINITIONS

DECIMAL
   HERE KERNELSTARTOFFSET +
   DUP KERNSTART ! DUP KERNPOS !
   CR .( Kernel start= ) U. CR

KERNFILENAME @ COUNT FILEINCL
ONLY FORTH ALSO DEFINITIONS

KERNSTART @ KERNPOS @ OVER - WRITEKERNEL

