
;
;
;
; MPFORTH MultiPlatform Forth system.
; P.W.Soft. 1999
;
;
;

		name            myforth
		title           myforth system
		.8086

; *******************************************************************
; Bootloader
; *******************************************************************

_TEXT           SEGMENT PARA PUBLIC 'CODE'

		assume cs:_TEXT,ds:_TEXT,ss:_STACK

kickstart       proc far

		; Setup data-stack
;		MOV		AX,CS
;		MOV		DS,AX


		; *** Load image
		; openfile

		; DS points to PSP
		MOV		DX,082h		; Commandline in PSP
		MOV		AL,DS:[080h]	; Commandline length

		SUB		AL,1		; Remove space and \n
		CMP		AL,4
		JBE		ERROR		; Filename to short
		MOV		BX,DX
		MOV		AH,0
		ADD		BX,AX		; Calculate end addr
		MOV	BYTE PTR DS:[BX],0	; Null terminate filename

		MOV		AX,03D00h	; OpenFile
		INT		21h
		JC		ERROR

		; read image
		PUSH		AX
		MOV		BX,AX		; FileHandle
		MOV		AX,_IMAGE	; Segment
		MOV		DS,AX
		MOV		DX,0
		MOV		CX,65535	; Max image size
		MOV		AX,03F00h	; ReadFile
		INT		21h

		; close file
		MOV		AX,03E00h	; CloseFile
		POP		BX
		INT		21h

		; *** Bootup Forth
		; store return address on the stack
		PUSH		CS
		MOV		AX,OFFSET ERROR
		PUSH		AX

		MOV		AX,_IMAGE
		MOV		DS,AX
		MOV		BX,0

		; call boot loader
		MOV		AX,OFFSET returnstack
		MOV		BP,AX
		XCHG		BP,SP
		PUSH		DS
		PUSH		DS:0[BX]
		RETF

		; *** Exit to dos
ERROR:		MOV     	AX,4c00h
		INT     	21h

kickstart       endp

imagename	db	"kernel.bin",0

_TEXT           ENDS


_IMAGE		SEGMENT PARA PUBLIC '_DATA'
		db	65535 dup(?)
_IMAGE		ENDS


_STACK          SEGMENT PARA STACK 'STACK'

		db       8192 dup(?)
returnstack     db      49152 dup(?)

_STACK          ENDS

		end     kickstart

