
CR

( MPForth kernel source )
( Copyright PW.Soft. 06/07/1999 )

( 8086 Register use: )

( AX - tmp )
( BX - always Top Of Stack )
( CX - loop counter )
( DX - tmp )
( SI - ? )
( DI - ? )
( BP - Return stack pointer )
( SP - Data stack pointer )


CR .( Defining work variables )
VARIABLE HNDL
VARIABLE IMAGELEN
VARIABLE KERNELEND

VARIABLE RELOCCOUNT 0 RELOCCOUNT !

: RELOCDICT ( addr -- )
   CR ( ." Relocating dictationary, " )
   KERNELEND @ BEGIN
      DUP 0<> WHILE
      DUP @ DUP -ROT ( -- new old new )
      METAOFFS @ - ( -- new old reloc ) DUP 0 < IF CLR ENDIF
      SWAP ! 1 RELOCCOUNT +!
   REPEAT DROP
   RELOCCOUNT @ DECIMAL . HEX ( ." Relocated." ) ;

: WRITEKERNEL ( addr len -- )
(   CR CR ." Writing kernel to disk:" )

   OVER .
   SWAP RELOCDICT SWAP

   CR ( ." Writing image filesize=" ) DECIMAL DUP . HEX
   C" MPFORTH.BIN" COUNT 0 CREATE-FILE IF
      ( ." Error creating kernel file." )
   ELSE
      HNDL !
      HNDL @ WRITE-FILE 2DROP
      HNDL @ CLOSE-FILE
   ENDIF

   BYE ;


CR .( Setting up meta compiler )

VARIABLE SSPLOC
VARIABLE SBPLOC

HEX
: _[ ['] [ EXECUTE ; IMMEDIATE
: _] ['] ] EXECUTE ; IMMEDIATE

: _, , ;
: _C, C, ;
: _@ @ ;
: :! ! ;

: _HERE HERE ;
: _METAOFFS METAOFFS ;
: _CR CR ;
: _BYE BYE ;
: _IMMEDIATE IMMEDIATE ;

: _COMPILE, COMPILE, ; IMMEDIATE
: _LIT LIT ; IMMEDIATE
: -> ' COMPILE, ; IMMEDIATE
: _( -> ( ; IMMEDIATE
: __( CR -> .( ; IMMEDIATE
: :.( -> .( ; IMMEDIATE
: :+ -> + ; IMMEDIATE
: :- -> - ; IMMEDIATE
: :: -> : ; IMMEDIATE
: :; -> ; ; IMMEDIATE
: _' -> ' ; IMMEDIATE

: _RET -> RET ; IMMEDIATE
: _RETF -> RETF ; IMMEDIATE
: _R<>D -> R<>D ; IMMEDIATE
: _BREAK 00CC C, ; IMMEDIATE

: MOV_[BX],BP 2F89 X, ; IMMEDIATE
: MOV_[BX],SP 2789 X, ; IMMEDIATE
: MOV_BP,[BX] 2F8B X, ; IMMEDIATE
: MOV_SP,[BX] 278B X, ; IMMEDIATE


CR .( Start meta compiling )
_HERE _METAOFFS !

0 , ( Start addr, needed by loader.exe and criticalerror handlers )
0 , ( Return seg )
0 , ( Return offs )
_HERE _METAOFFS @ - SSPLOC ! 0 , ( SSP )
_HERE _METAOFFS @ - SBPLOC ! 0 , ( SBP )
VARIABLE BOOT
VARIABLE STATE
VARIABLE IMMSTART     FB00 IMMSTART !
VARIABLE IMMPOS
VARIABLE HEREP        HIDDEN
VARIABLE METAOFFS     0000 METAOFFS !
VARIABLE LASTINSTR    0000 LASTINSTR !

VARIABLE TIBLOC
VARIABLE TIB#
VARIABLE >IN
VARIABLE CHARBUF
VARIABLE SOURCE       0000 SOURCE !

VARIABLE BASE         000A BASE !
CREATE INCLSTACK      10 ALLOT
VARIABLE INCLSP


HERE _METAOFFS @ - 0 ,  ( Root vocabulary )
VARIABLE ROOTVOC      ROOTVOC !
VARIABLE USEVOC       ROOTVOC @ USEVOC !
VARIABLE CURVOC       0000 CURVOC !
VARIABLE DEFVOC       ROOTVOC @ DEFVOC !
VARIABLE FIXUP        0000 FIXUP !


0000 CONSTANT FLAG_PROCEDURE
0001 CONSTANT FLAG_IMMEDIATE
0002 CONSTANT FLAG_VARIABLE
0003 CONSTANT FLAG_CONSTANT
0080 CONSTANT FLAG_HIDDEN

0000 CONSTANT FALSE
FFFF CONSTANT TRUE


CR .( Building memory contol )

0002 CONSTANT CELL ;
: HERE  HEREP @ ;
: CELL+ CELL + ;
: CELLS CELL * ;
: ALLOT HEREP +! ;
:  , HERE  ! CELL ALLOT ;
: C, HERE C!    1 ALLOT ;

: X,     STATE @ IF  , ELSE IMMPOS SWAP OVER @  ! CELL SWAP +! ENDIF ;
: XC,    STATE @ IF C, ELSE IMMPOS SWAP OVER @ C!    1 SWAP +! ENDIF ;
: RELOC  STATE @ IF METAOFFS @ - ENDIF ;
: XP     STATE @ IF HERE ELSE IMMPOS @ ENDIF ;
: I,     STATE @ IF DUP LASTINSTR ! X,  ( do optimize ) ELSE X, ENDIF ;
: IC,    STATE @ IF DUP LASTINSTR ! XC, ( do optimize ) ELSE XC, ENDIF ;
: CLROPT 0000 LASTINSTR ! ;
: WASINSTR ( instr -- fl  ; Test if instr was last instruction )
   LASTINSTR @ = STATE @ AND ;

: R<>D
   EC87 WASINSTR IF
      -2 ALLOT CLROPT
   ELSE
      EC87 I,
   ENDIF ; IMMEDIATE
( : ->D
( : ->R
: RET       00C3 IC, ; IMMEDIATE
: RETF      00CB IC, ; IMMEDIATE
: LIT       0053 IC, ( PUSH_BX ) 00BB XC, X, ( MOV_BX,# ) ;
: COMPILE,  -> R<>D 00E8 IC, XP RELOC - 0002 - X, -> R<>D ; _( IMMEDIATE )


CR .( Building kernel )
: OFF    0 SWAP ! ;
: ON  FFFF SWAP ! ;

CR .( Building vocabularies )
: ONLY         0000 USEVOC ! ;
: FORTH        ROOTVOC @ CURVOC ! ;
: ALSO         CURVOC @ USEVOC ! ;
: DEFINITIONS  CURVOC @ DEFVOC ! ;

: G_INIT ( --  ; init immediate mode )
   IMMSTART @ IMMPOS ! -> R<>D ; HIDDEN
: G ( --  ; Execute all immidiate compiled so far )
   STATE @ 0= IF
      -> R<>D -> RET IMMSTART @ EXECUTE G_INIT
   ENDIF ; HIDDEN

: ]
   STATE OFF G STATE ON ; IMMEDIATE
: [
   STATE OFF G ; IMMEDIATE

__( Building I/O functions )
: DOSCALL ( dx cx ax bx -- ax cf )
   _R<>D PUSH_CX _R<>D
   POP_AX POP_CX POP_DX _[ 0021 _] INT_# PUSH_AX SBB_BX,BX
   _R<>D POP_CX _R<>D ;

: CREATE-FILE ( name len attrib -- hndl cf  ; Create file )
   NIP 3C00 DUP ( nop_bx ) DOSCALL ;
: OPEN-FILE ( name len mode -- hndl cf  ; Open existing file )
   NIP DUP ( nop_cx )
   00FF AND 3D00 OR
   DUP ( nop_bx ) DOSCALL ;
: READ-FILE ( a c hndl -- err? )
   3F00 SWAP DOSCALL ;
: WRITE-FILE ( a c hndl -- )
   4000 SWAP DOSCALL 2DROP ;
: CLOSE-FILE ( hndl -- ior )
   DUP DUP ( dummy dx&cx ) 3E00 SWAP DOSCALL
   NIF CLR ENDIF ;

: EMIT ( char --  ; Display char on the screen )
   MOV_DX,BX _[ 0200 _] MOV_AX,# _[ 0021 _] INT_# POP_BX ;

: KEY ( -- key  ; Get ascii code last pressed key )
(   PUSH_BX _[ 0700 _] MOV_AX,# _[ 0021 _] INT_#
(   MOV_BX,AX _[ 0 _] MOV_BH,# ;
   PUSH_BX _[ 0000 _] MOV_AX,# _[ 0016 _] INT_#
   MOV_BX,AX _[ 0 _] MOV_BH,# ;

: BEEP ( --  ; Beep )
   0007 EMIT ;

: CR   ( --  ; Next line )
   000D EMIT 000A EMIT ;

: COUNT ( str -- addr len  ; convert counted string to addr+len)
   DUP 1+ SWAP C@ ;

: TYPE ( addr len --  ; Output buffer )
   1 WRITE-FILE ;

: TYPES ( str --  ; Output string )
   COUNT TYPE ;

: SAVE ( name len -- ; Save system to disk )
   0 CREATE-FILE IF
      C" Error creating image" TYPES CR DROP
   ELSE
      DUP 0 HERE ROT WRITE-FILE CLOSE-FILE DROP
      C" Image written" TYPES CR
   ENDIF ;

: PUSHINCL ( filehndl -- )
   INCLSP @ ! INCLSP @ CELL + INCLSP ! ;

: POPINCL ( -- filehndl )
   INCLSP @ CELL - DUP INCLSP ! @ ;

: CHARINPUT ( -- n1 ; Read char from default input found in SOURCE )
   SOURCE @ 0<> IF
      CHARBUF 1 SOURCE @ READ-FILE DROP 0= IF ( EOF? )
         SOURCE @ CLOSE-FILE DROP POPINCL SOURCE ! 000D
      ELSE
         CHARBUF @
      ENDIF
   ELSE
      KEY
   ENDIF ;

__( Building EXPECT )
: EXPECT ( buf maxlen -- len  ; Read line from console to buf )
   0000 ROT ( -- maxlen len buf )
   BEGIN CHARINPUT ( -- maxlen len buf key )
      DUP 000D <> WHILE
      DUP 000A <> IF ( Skip LineFeeds in input )
         DUP 0008 = IF
            2SWAP DUP 0= IF
               2SWAP BEEP DROP
            ELSE
               1- 2SWAP DUP EMIT 0020 EMIT EMIT
            ENDIF
         ELSE
            2SWAP 2DUP = IF ( len=maxlen? )
               2SWAP BEEP DROP
            ELSE
               2SWAP SOURCE @ 0= IF DUP EMIT ENDIF ( -- maxlen len buf key )
               >R 2DUP + R> SWAP C! ( -- maxlen len buf )
               SWAP 1+ SWAP  ( -- maxlen len+1 buf )
            ENDIF
         ENDIF
      ELSE DROP
      ENDIF
   REPEAT ( -- maxlen len buf key )
   DROP DROP NIP SOURCE @ 0= IF 0020 EMIT ENDIF ;

: QUERY ( --  ; Get inputline and write it to TIB )
   FF80 TIBLOC ! TIBLOC @ 004E EXPECT TIB# ! 0 >IN ! ;

: TOUPPER ( ch -- ch  ; Convert char to uppercase )
   DUP ASCII a >= OVER ASCII z <= AND IF 0020 - ENDIF ;
: TOLOWER ( ch -- ch  ; Convert char to lowercase )
   DUP ASCII A >= OVER ASCII Z <= AND IF 0020 + ENDIF ;

: 2INC ( n1 n2 -- n1+1 n2+1  ; update 2 pointers )
   SWAP 1+ SWAP 1+ ;

: MOVE ( addr1 addr2 len --  ; move 'len' bytes from addr1 to addr2 )
   BEGIN DUP 0<> WHILE     ( -- src dest len )
   1- -ROT OVER C@ OVER C! ( -- len src dest  ; copy 1 char )
   2INC ROT REPEAT 3DROP ;

: BUF2STR ( src dest len -- ; move 'len' bytes from src to cstr dest )
   2DUP SWAP C!        ( -- src dest len  ; write string len )
   2DUP + 1+ 0 SWAP C! ( -- src dest len ; write 0 terminator for sys-intf )
   -ROT 1+ ROT         ( -- src dest len  ; skip countbyte when copying )
   MOVE ;

: WORDTIBPOS ( -- curtibpos  ; get current loc in TIB )
   TIBLOC @ >IN @ + ; HIDDEN

: WORDSKIP ( char -- char  ; skip all char's in TIB )
   BEGIN
      >IN @ TIB# @ < WHILE
      WORDTIBPOS C@ OVER = WHILE
      1 >IN +!
   REPEAT ; HIDDEN

: WORDLEN ( sep -- sep len  ; Find length of 'word' )
   >IN @ SWAP BEGIN  ( pos sep -- )
   OVER TIB# @ < WHILE
   OVER TIBLOC @ + C@ OVER <> WHILE
   SWAP 1+ SWAP
   REPEAT SWAP >IN @ - ; HIDDEN

__( Building WORD)
: WORD ( sep -- here  ; Copy string from input to HERE skip sep )
   WORDSKIP WORDLEN NIP DUP ( -- len len )
   WORDTIBPOS ( -- len len src )
   HERE ROT  ( -- len src dest len )
   BUF2STR ( -- len  ; copy string )
   1+ >IN +! ( --  ; update >IN )
   HERE ; ( -- here  ; return location of string )

: FINDCMP ( name defname -- fl  ; Is name same as defname ? )
   1 -ROT ( fl name defname )
   2DUP C@ SWAP C@ = IF
      DUP C@ ( fl name defname len )
      BEGIN -ROT ( fl len name defname )
         2INC 2DUP C@ TOUPPER SWAP C@ TOUPPER <> IF
            >R >R >R CLR R> R> R>
         ENDIF ROT 1- DUP 0=
      UNTIL 3DROP
   ELSE 2DROP CLR
   ENDIF ; HIDDEN

_CR .( Building FIND )
: (FIND ( addr name def -- addr name )
   0 BEGIN
      SWAP @ SWAP 0= OVER 0<> AND WHILE
      2DUP 3 + FINDCMP DUP ( -- addr name def fl fl )
      IF >R ROT DROP DUP -ROT R> ENDIF ( -- addr name def fl )
   AGAIN DROP ; HIDDEN
: FIND ( name -- addr  ; Find procedure by name )
   0 SWAP ( -- addr name )
   USEVOC @ DUP 0<> IF
      (FIND
   ELSE
      DROP
   ENDIF

   OVER 0= IF
      ROOTVOC @ (FIND
   ENDIF

   DROP ;

(    ROOTVOC @ @ BEGIN ( -- addr name def )
(       2DUP 3 + FINDCMP DUP ( -- addr name def fl fl )
(       IF >R ROT DROP DUP -ROT R> ENDIF ( -- addr name def fl )
(       SWAP @ SWAP OVER 0= OR
(    UNTIL 2DROP ;

__( Building compiling primitives )
: HEADER ( type --  ; Make word header )
   HERE DEFVOC @ DUP @ , ! C, ( --  ; fix link, register type )
   0020 WORD C@ 1+ ALLOT ; ( --  ; Register name )
: CALCCODEADDR ( defaddr -- codeaddr  ; calculate code start point )
   2+ 1+ DUP C@ + 1+ ; HIDDEN
: VARIABLE ( --  ; Create variable )
   FLAG_VARIABLE HEADER 0 DUP , , ;
: CONSTANT ( n1 --  ; Create constant )
   FLAG_CONSTANT HEADER 0 , , ;
: CREATE ( --  ; Create null storage variable )
   FLAG_VARIABLE HEADER 0 , ;
: DODOES
   DEFVOC @ @ CALCCODEADDR RELOC ! ;
: DOES>
   STATE @ IF
      0 LIT XP ['] DODOES COMPILE, -> R<>D -> RET
      CELL - XP SWAP ! -> R<>D
   ELSE
      C" Error in DOES> not compiling." TYPES CR
   ENDIF ; IMMEDIATE
(   -> R<>D -> RET ;

__( Building PAD )
: PAD ( -- addr  ; get adres of temp loc on the heap )
   HERE 0100 + ;

__( Building ATOI# )
: ATOI# ( char -- n fl  ; Convert one char to number )
   TOUPPER DUP ASCII A >= IF 0007 - ENDIF ASCII 0 -

   DUP 0 >= OVER BASE @ < AND IF ( number ? )
      TRUE
   ELSE
      CLR DUP
   ENDIF ;

__( Building U_ATOI )
: U_ATOI ( addr len -- un fl  ; Convert to unsigned num, fl=true conv ok )
    >R >R 0 TRUE R> R> ( -- num fl addr len )
    BEGIN
       DUP 0<>
    WHILE
      SWAP ( -- num fl len str+1 )
      DUP C@ ATOI# ( -- num fl len str n fl )
      IF
         >R 2SWAP SWAP BASE @ * R> + SWAP 2SWAP ( increase num )
      ELSE
         DROP 2SWAP CLR 2SWAP ( clear ok flag )
      ENDIF 1+ SWAP 1-
    REPEAT 2DROP ;

__( Building ATOI )
: ATOI ( str -- n fl  ; Convert string to number, fl=true conv ok )
   COUNT OVER C@ ASCII - = IF  ( negative? )
      SWAP 1+ SWAP 1- U_ATOI SWAP NEGATE SWAP
   ELSE
      U_ATOI
   ENDIF ;

__( Building INTERPRET )
: INTERPRET ( defaddr --  ; Compile assembly code for current word )
   DUP 2+ C@ 007F AND ( -- defaddr type&127 )

   DUP FLAG_PROCEDURE = IF
      DROP CALCCODEADDR @ -> COMPILE,
   ELSE DUP FLAG_IMMEDIATE = IF
      DROP CALCCODEADDR @ EXECUTE
   ELSE DUP FLAG_VARIABLE = IF
      DROP CALCCODEADDR DUP 2+ RELOC LIT
      @ DUP 0<> IF -> COMPILE, ELSE DROP ENDIF
   ELSE DUP FLAG_CONSTANT = IF
      DROP CALCCODEADDR 2+ @ LIT
   ELSE
      DROP
   ENDIF ENDIF ENDIF ENDIF ;

__( Building RUN )
: RUN ( --  ; Interpret input and process )
   BEGIN >IN @ TIB# @ < WHILE
      0020 WORD DUP DUP C@ 0<> IF
         FIND DUP 0= IF
( C"  Not found" TYPES CR )
            ( word not found, try as literal )
            DROP DUP ATOI IF
               NIP LIT  ( compile number )
            ELSE
               DROP CR TYPES C"  <- Wrong keyword " TYPES
            ENDIF
         ELSE
( C"  Found" TYPES CR )
            ( word found, compile and/or execute )
            NIP INTERPRET ( _BREAK ) G
         ENDIF
      ENDIF
   REPEAT G ;

__( Building BYE )
: BYE ( --  ; Leave system )
   _[ 4 _] MOV_BX,# MOV_BX,[BX] PUSH_BX
   _[ 2 _] MOV_BX,# MOV_BX,[BX] PUSH_BX
   _RETF ;

: PROMPT
   C"  ok>" TYPES CR ;

: ?PROMPT
   SOURCE @ 0= IF STATE @ IF CR ELSE PROMPT ENDIF ENDIF ;

: QUIT ( The QUIT interpreter loop )
   STATE OFF G_INIT
   BEGIN
(      EOFQUIT @ 0= WHILE
      QUERY RUN ?PROMPT
   REPEAT ;

: FILEINCL ( name len -- )
   SOURCE @ PUSHINCL
   0 OPEN-FILE IF
      C" Error opening file" TYPES CR DROP
   ELSE
      SOURCE ! ( QUIT )
   ENDIF ;

: INCLUDE ( |name -- )
   0020 WORD COUNT FILEINCL ;

: SAVEAS
   0020 WORD COUNT SAVE ;

: BOOTMSG
   CR C" MPForth 0.9.718 PW.Soft. 1999" TYPES CR ;

__( Building BOOT )
: (BOOT ( --  ; create boot routine )
   BOOTMSG  ( Display Boot message )
(   EOFQUIT OFF
   QUIT     ( Start interpreter )
   BYE      ( Failsave call to BYE )
;

: RESET ( --  ; Reset system in clean state )
   _[ SSPLOC @ _] MOV_BX,# MOV_SP,[BX]
   _[ SBPLOC @ _] MOV_BX,# MOV_BP,[BX]
   _[ 0 _] MOV_BX,#
   BOOT @ EXECUTE ;

: INIT_SYS ( --  ; Global system init, calls boot )
   POP_AX _[ 2 _] MOV_BX,# MOV_[BX],AX ( --  ; store bye jump seg )
   POP_AX _[ 4 _] MOV_BX,# MOV_[BX],AX ( --  ; store bye jump offs )

   _[ SSPLOC @ _] MOV_BX,# MOV_[BX],SP
   _[ SBPLOC @ _] MOV_BX,# MOV_[BX],BP
   INCLSTACK INCLSP !

   RESET ; HIDDEN

: HEX     0010 BASE ! ;
: DECIMAL 000A BASE ! ;
: OCTAL   0008 BASE ! ;
: BIN     0002 BASE ! ;


__( Building DEPTH )
: DEPTH _( -- n  ; Push stack depth )
   _[ SSPLOC @ _] PUSH_BX MOV_BX,# MOV_BX,[BX]
   MOV_AX,SP SUB_BX,AX SAR_BX,1 1- ;

: .( ASCII ) WORD TYPES ; IMMEDIATE
: ( ASCII ) WORD DROP ; IMMEDIATE

: IMMEDIATE _( --  ; Change wordtype to imm )
   DEFVOC @ @ 2+ DUP C@ FLAG_IMMEDIATE OR SWAP C! ;
: HIDDEN _( --  ; Change wordtype to imm )
   DEFVOC @ @ 2+ DUP C@ FLAG_HIDDEN OR SWAP C! ;


__( Building assembler )
: ADD_BX,AX      D803 I, ; _IMMEDIATE
: ADD_[BX],AX    0701 I, ; _IMMEDIATE
: ADD_BP,#       C583 I, XC, ; _IMMEDIATE
: ADD_CX,BX      CB03 I, ; _IMMEDIATE

: AND_BX,AX      D823 I, ; _IMMEDIATE

: CALL_AX        D0FF I, ; _IMMEDIATE
: CMP_BX,AX      D83B I, ; _IMMEDIATE
: CMP_CX,DX      CA3B I, ; _IMMEDIATE

: DIV_BX         F3F7 I, ; _IMMEDIATE

: FIXFWD         DUP IF XP OVER - 0002 - SWAP !
                 ELSE DROP ENDIF ; _IMMEDIATE _( See also JMPFWD )

: INC_CX         0041 IC, ; _IMMEDIATE

: INT_#          00CD IC, XC, ; _IMMEDIATE

: JE             0074 IC, ; _IMMEDIATE
: JG             007F IC, ; _IMMEDIATE
: JGE            007D IC, ; _IMMEDIATE
: JL             007C IC, ; _IMMEDIATE
: JLE            007E IC, ; _IMMEDIATE
: JNE            0075 IC, ; _IMMEDIATE
: JMP            00E9 IC, ; _IMMEDIATE
: JMP_#          00E9 IC, XP _( RELOC ) - 0002 - X, ; _IMMEDIATE
: JMPFWD         00E9 IC, XP 0 X, ; _IMMEDIATE

: MOV_AX,BX      C38B I, ; _IMMEDIATE
: MOV_AX,SP      C48B I, ; _IMMEDIATE
: MOV_AX,#       00B8 IC, X, ; _IMMEDIATE
: MOV_BX,AX      D88B I, ; _IMMEDIATE
: MOV_BX,CX      D98B I, ; _IMMEDIATE
: MOV_BX,DX      DA8B I, ; _IMMEDIATE
: MOV_BX,[BX]    1F8B I, ; _IMMEDIATE
: MOV_BX,#[BP]   5E8B I, XC, ; _IMMEDIATE
: MOV_BX,#       00BB IC, X, ; _IMMEDIATE
: MOV_BL,[BX]    1F8A I, ; _IMMEDIATE
: MOV_BH,#       00B7 IC, XC, ; _IMMEDIATE
: MOV_[BX],AL    0788 I, ; _IMMEDIATE
: MOV_[BX],AX    0789 I, ; _IMMEDIATE
: MOV_CX,BX      CB8B I, ; _IMMEDIATE
: MOV_DX,BX      D38B I, ; _IMMEDIATE
: MOV_DX,#[BP]   568B I, XC, ; _IMMEDIATE

: MUL_BX         E3F7 I, ; _IMMEDIATE

: OR_BX,AX       D80B I, ; _IMMEDIATE

: POP_AX         0050 WASINSTR IF
                    -1 ALLOT CLROPT
                 ELSE
                    0058 IC,
                 ENDIF ; _IMMEDIATE
: POP_BX         005B IC, ; _IMMEDIATE
: POP_CX         0059 IC, ; _IMMEDIATE
: POP_DX         005A IC, ; _IMMEDIATE
: PUSH_AX        0050 IC, ; _IMMEDIATE
: PUSH_BX        0053 IC, ; _IMMEDIATE
: PUSH_CX        0051 IC, ; _IMMEDIATE
: PUSH_DX        0052 IC, ; _IMMEDIATE

: SAR_BX,1       FBD1 I, ; _IMMEDIATE
: SBB_BX,BX      DB1B I, ; _IMMEDIATE
: SUB_BX,AX      D82B I, ; _IMMEDIATE
: SUB_BX,#       EB83 I, XC, ; _IMMEDIATE
: SUB_DX,DX      D22B I, ; _IMMEDIATE

: TEST_BX,BX     DB1B WASINSTR NIF DB85 I, ENDIF ; _IMMEDIATE

: XCHG_AX,BX     0093 IC, ; _IMMEDIATE
: XCHG_#[BP],AX  4687 I, XC, ; _IMMEDIATE
: XCHG_#[BP],BX  5E87 I, XC, ; _IMMEDIATE

: >R  -> R<>D -> PUSH_BX -> R<>D -> POP_BX ; _IMMEDIATE
: R>  -> PUSH_BX -> R<>D -> POP_BX -> R<>D ; _IMMEDIATE
: R@  -> PUSH_BX 0 -> MOV_BX,#[BP] ; _IMMEDIATE

: C"
   -> JMPFWD
   ASCII " WORD _( -- afix here )
   DUP C@ 1+ ALLOT
   0 C, _( -- afix here  ; null terminate string )
   SWAP -> FIXFWD RELOC LIT ; _IMMEDIATE
_( : ." -> C" _[ ['] TYPES COMPILE, _] ; _IMMEDIATE
_( : ." -> C" _[ ['] TYPES LIT _] COMPILE, ; IMMEDIATE
: ' _( | name -- cfa  ; Search word and provide cfa )
   0020 WORD FIND CALCCODEADDR @ ;
: ['] _( | name -- cfa ) ' LIT ; _IMMEDIATE
: ASCII _( -- ch )
   0020 WORD 1+ C@ LIT ; _IMMEDIATE


__( Buiding control structures )
: BEGIN _( -- oldfixup a1 )
   FIXUP @ 0 FIXUP ! XP
   CLROPT ; _IMMEDIATE
: WHILE _( a1 -- afix a1 )
   -> TEST_BX,BX -> POP_BX
   -> JNE 3 -> XC, -> JMPFWD SWAP
   1 FIXUP +! ; _IMMEDIATE
: UNTIL _( oldfixup .. afix a1 -- )
   -> TEST_BX,BX -> POP_BX
   -> JNE 3 -> XC, -> JMP_#
   FIXUP @ 0 2DUP <> IF
      DO -> FIXFWD LOOP
   ELSE 2DROP
   ENDIF FIXUP ! CLROPT ; _IMMEDIATE
: REPEAT _( oldfixup .. afix a1 -- )
   -> JMP_#
   FIXUP @ 0 2DUP <> IF
      DO -> FIXFWD LOOP
   ELSE 2DROP
   ENDIF FIXUP ! CLROPT ; _IMMEDIATE
: AGAIN -> REPEAT ; _IMMEDIATE
: IF _( -- afix )
   -> TEST_BX,BX -> POP_BX
   -> JNE 3 XC, -> JMPFWD
   CLROPT ; _IMMEDIATE
: NIF _( -- afix )
   -> TEST_BX,BX -> POP_BX
   -> JE 3 XC, -> JMPFWD
   CLROPT ; _IMMEDIATE
: ELSE _( afix -- afix )
   -> JMPFWD SWAP -> FIXFWD
   CLROPT ; _IMMEDIATE
: ENDIF _( afix -- )
   -> FIXFWD
   CLROPT ; _IMMEDIATE

: DO _( Compile: -- afix1 afix2  )
     _( Runtime: lim start --  ; begin loop )
   -> R<>D -> PUSH_CX -> R<>D   _( Store CX=counter )
   -> MOV_CX,BX -> POP_BX -> >R _( Init counter and limit )
   0 XP _( Jumpback addr ) ; _IMMEDIATE
: ?DO _( Compile: -- afix1 afix2 )
      _( Runtime: lim start --  ; begin loop )
   -> R<>D -> PUSH_CX -> R<>D _( Store CX=counter )
   -> MOV_CX,BX -> POP_BX -> MOV_DX,BX -> >R _( Init counter and limit )
   -> CMP_CX,DX -> JL 3 XC, -> JMPFWD -> XP _( Jumpback addr )
; _IMMEDIATE
: LOOP _( Compile: afix1 afix2 --  ; End a loop construct )
       _( Runtime: -- )
   -> INC_CX 0 -> MOV_DX,#[BP]
   -> CMP_CX,DX -> JGE 3 XC, -> JMP_#
   -> FIXFWD -> R<>D  -> POP_CX -> POP_CX -> R<>D ; _IMMEDIATE
: +LOOP _( Compile: afix1 afix2 --  ; End a loop construct )
        _( Runtime: n1 -- )
   -> ADD_CX,BX -> POP_BX 0 -> MOV_DX,#[BP]
   -> CMP_CX,DX -> JGE 3 -> XC, -> JMP_#
   -> FIXFWD -> R<>D  -> POP_CX -> POP_CX -> R<>D ; _IMMEDIATE
: I -> PUSH_BX -> MOV_BX,CX ; _IMMEDIATE
: J -> PUSH_BX 2 -> MOV_BX,#[BP] ; _IMMEDIATE
: K -> PUSH_BX 6 -> MOV_BX,#[BP] ; _IMMEDIATE

:: :NONAME -> ] XP -> R<>D :; _IMMEDIATE
:: : -> ] FLAG_PROCEDURE HEADER XP RELOC 2+ , -> R<>D :; _IMMEDIATE
:: ; -> R<>D -> RET -> [ :; _IMMEDIATE


__( Building Forth primitives )
:: 1+           0043 IC, :; _IMMEDIATE
:: 1-           004B IC, :; _IMMEDIATE
:: 2+           4343 I, :; _IMMEDIATE
:: 2-           4B4B I, :; _IMMEDIATE
:: NEGATE       DBF7 I, :; _IMMEDIATE


:: =            -> POP_AX -> SUB_BX,AX 1
                -> SUB_BX,# -> SBB_BX,BX :; _IMMEDIATE
:: 0=           1 -> SUB_BX,# -> SBB_BX,BX :; _IMMEDIATE
:: <>           -> POP_AX -> SUB_BX,AX
                -> NEGATE -> SBB_BX,BX :; _IMMEDIATE
:: 0<>          -> NEGATE -> SBB_BX,BX :; _IMMEDIATE
:: <            -> POP_AX -> CMP_BX,AX 0 -> MOV_BX,#
                -> JLE 1 XC, -> 1- :; _IMMEDIATE
:: <=           -> POP_AX -> CMP_BX,AX 0 -> MOV_BX,#
                -> JL  1 XC, -> 1- :; _IMMEDIATE
:: >            -> POP_AX -> CMP_BX,AX 0 -> MOV_BX,#
                -> JGE 1 XC, -> 1- :; _IMMEDIATE
:: >=           -> POP_AX -> CMP_BX,AX 0 -> MOV_BX,#
                -> JG  1 XC, -> 1- :; _IMMEDIATE
:: AND          -> POP_AX -> AND_BX,AX :; _IMMEDIATE
_( :: NOT       -> SHL_BX,1 -> SBB_BX,BX :; _IMMEDIATE )
:: OR           -> POP_AX -> OR_BX,AX :; _IMMEDIATE


:: +            -> POP_AX -> ADD_BX,AX :; _IMMEDIATE
:: -            -> MOV_AX,BX -> POP_BX -> SUB_BX,AX :; _IMMEDIATE
:: *            -> MOV_AX,BX -> POP_BX -> MUL_BX -> MOV_BX,AX :; _IMMEDIATE
:: U/MOD        -> POP_AX -> SUB_DX,DX -> DIV_BX
                -> PUSH_DX -> MOV_BX,AX :; _IMMEDIATE
:: UM/MOD       -> POP_DX -> POP_AX -> DIV_BX -> PUSH_DX
                -> MOV_BX,AX :; _IMMEDIATE

:: @            -> MOV_BX,[BX] :; _IMMEDIATE
:: !            -> POP_AX -> MOV_[BX],AX -> POP_BX :; _IMMEDIATE
:: +!           -> POP_AX -> ADD_[BX],AX -> POP_BX :; _IMMEDIATE
:: C@           -> MOV_BL,[BX] 0 -> MOV_BH,# :; _IMMEDIATE
:: C!           -> POP_AX -> MOV_[BX],AL -> POP_BX :; _IMMEDIATE

:: DROP         -> POP_BX :; _IMMEDIATE
:: DUP          -> PUSH_BX :; _IMMEDIATE
:: NIP          -> POP_AX :; _IMMEDIATE
:: OVER         -> POP_AX -> PUSH_AX -> XCHG_AX,BX -> PUSH_AX :; _IMMEDIATE
:: ROT          -> POP_DX -> POP_AX -> PUSH_DX
                -> XCHG_AX,BX -> PUSH_AX :; _IMMEDIATE
:: -ROT         -> POP_DX -> POP_AX -> PUSH_BX
                -> MOV_BX,DX -> PUSH_AX :; _IMMEDIATE
:: SWAP         -> POP_AX -> XCHG_AX,BX -> PUSH_AX :; _IMMEDIATE
:: CLR          0 -> MOV_BX,# :; _IMMEDIATE

:: 2DROP        -> POP_BX -> POP_BX :; _IMMEDIATE
:: 2DUP         -> POP_AX -> PUSH_AX -> PUSH_BX -> PUSH_AX :; _IMMEDIATE
:: 2SWAP _( n1 n2 n3 n4 -- n3 n4 n1 n2 )
                -> POP_AX -> R<>D 2 -> XCHG_#[BP],AX
                0 -> XCHG_#[BP],BX -> R<>D -> PUSH_AX :; _IMMEDIATE

:: 3DROP        -> POP_BX -> POP_BX -> POP_BX :; _IMMEDIATE
:: 3DUP         -> POP_AX -> POP_DX -> PUSH_DX
                -> PUSH_AX -> PUSH_BX -> PUSH_DX -> PUSH_AX :; _IMMEDIATE

:: EXECUTE      -> MOV_AX,BX -> POP_BX -> R<>D
                -> CALL_AX -> R<>D :; _IMMEDIATE

__( Finishing kernel build )

_( Don't remove/change anything below this line )
_HERE _METAOFFS _@ :- ROOTVOC _@ _METAOFFS _@ :+ :!
_HERE KERNELEND :!
:: NOOP :;

__( Init image )
_HERE _METAOFFS _@ :- HEREP :!
_' (BOOT BOOT :!
_' INIT_SYS _METAOFFS _@ :!

__( Writing kernel image to file. ) _CR
HEREP _@ IMAGELEN :!
_METAOFFS _@ IMAGELEN _@ WRITEKERNEL

_( System is not comming back here, because interpreter is
_(  disabled after writing kernel to disk. This is caused by
_(  the relocation of the dictionary pointers !

